import os
from typing import *
from bag.design import Module

from sal.testbench_params import *


yaml_file = os.path.join(f'{os.environ["BAG_GENERATOR_ROOT"]}/BagModules/opamp_two_stage_fullchip_templates',
                         'netlist_info', 'opamp_two_stage_fullchip.yaml')


# noinspection PyPep8Naming
class schematic(Module):
    """Module for library opamp_two_stage_fullchip_templates cell opamp_two_stage_fullchip.

    Fill in high level description here.
    """

    def __init__(self, bag_config, parent=None, prj=None, **kwargs):
        super().__init__(bag_config, yaml_file, parent=parent, prj=prj, **kwargs)
       
    @classmethod
    def get_params_info(cls) -> Dict[str, str]:
        """Returns a dictionary from parameter names to descriptions.

        Returns
        -------
        param_info : Optional[Dict[str, str]]
            dictionary from parameter names to descriptions.
        """
        return dict(
            opamp_sch_params='Opamp schematic parameters dictionary',
            cap_sch_params='Load capacitor schematic parameters dictionary',
            buffer_sch_params='Buffer schematic parameters dictionary',
            dmux_2to1_sch_params='DMUX 2:1 schematic parameters dictionary'
        )

    def design(self,
               opamp_sch_params: Dict[str, Any],
               cap_sch_params: Dict[str, Any],
               buffer_sch_params: Dict[str, Any],
               dmux_2to1_sch_params: Dict[str, Any]):
        """To be overridden by subclasses to design this module.

        This method should fill in values for all parameters in
        self.parameters.  To design instances of this module, you can
        call their design() method or any other ways you coded.

        To modify schematic structure, call:

        rename_pin()
        delete_instance()
        replace_instance_master()
        reconnect_instance_terminal()
        restore_instance()
        array_instance()
        """

        self.instances['Top_Amp'].design(**opamp_sch_params)
                                         # {'Amp_params': Amp_params,
                                         #    'CMFB_params': CMFB_params,
                                         #    'dRes_params': dRes_params,
                                         #    'Cap_params': Cap_params,
                                         #    'MUX_2to1_params': MUX_2to1_params,
                                         #    'MUX_SW_params': MUX_SW_params,
                                         #    'PRes_params': PRes_params,
                                         #    'HVDD_params': HVDD_params})
        self.instances['CLP'].design(**cap_sch_params)
        self.instances['CLN'].design(**cap_sch_params)
        self.instances['Buff_p'].design(**buffer_sch_params)
        self.instances['Buff_n'].design(**buffer_sch_params)
        self.instances['TEST_Buff'].design(**buffer_sch_params)
        self.instances['DMUXN'].design(**dmux_2to1_sch_params)
        self.instances['DMUXP'].design(**dmux_2to1_sch_params)


class dut_wrapper_schematic(Module):
    """DUT wrapper to adapt cell generated by this generator (DUT)
    to the expected pinout of the testbench.
    """
    def __init__(self, database, parent=None, prj=None, **kwargs):
        yaml_file = os.path.join(f'{os.environ["BAG_GENERATOR_ROOT"]}/BagModules/opamp_two_stage_fullchip_templates',
                                 'netlist_info', 'opamp_two_stage_fullchip_dut_wrapper.yaml')
        Module.__init__(self, database, yaml_file, parent=parent, prj=prj, **kwargs)

    @classmethod
    def get_params_info(cls) -> Dict[str, str]:
        """
        Returns a dictionary from parameter names to descriptions.

        Returns
        -------
        param_info : Optional[Dict[str, str]]
            dictionary from parameter names to descriptions.
        """
        return dict(
            params='Testbench params',
        )

    def design(self,
               params: TestbenchParamsBase):
        """To be overridden by subclasses to design this module.

        This method should fill in values for all parameters in
        self.parameters.  To design instances of this module, you can
        call their design() method or any other ways you coded.

        To modify schematic structure, call:

        rename_pin()
        delete_instance()
        replace_instance_master()
        reconnect_instance_terminal()
        restore_instance()
        array_instance()
        """
        self.replace_instance_master(inst_name='XDUT',
                                     lib_name=params.dut.lib,
                                     cell_name=params.dut.cell,
                                     static=True)
